diff --git a/board/gdsys/a38x/MAINTAINERS b/board/gdsys/a38x/MAINTAINERS
index 3cb9b63ff0..d31e675ddc 100644
--- a/board/gdsys/a38x/MAINTAINERS
+++ b/board/gdsys/a38x/MAINTAINERS
@@ -1,6 +1,6 @@
 A38X BOARD
-M:	Dirk Eibach <eibach@gdsys.cc>
-M:	Mario Six <six@gdsys.de>
+M:	Dirk Eibach <dirk.eibach@gdsys.cc>
+M:	Mario Six <mario.six@gdsys.cc>
 S:	Maintained
 F:	board/gdsys/a38x/
 F:	include/configs/controlcenterdc.h
diff --git a/board/gdsys/common/adv7611.c b/board/gdsys/common/adv7611.c
index b728274cce..5355292280 100644
--- a/board/gdsys/common/adv7611.c
+++ b/board/gdsys/common/adv7611.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach, Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach, Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/fanctrl.c b/board/gdsys/common/fanctrl.c
index 44569bb1ab..52a4f33836 100644
--- a/board/gdsys/common/fanctrl.c
+++ b/board/gdsys/common/fanctrl.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2015
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/fpga.c b/board/gdsys/common/fpga.c
index e10c105feb..09c0446f90 100644
--- a/board/gdsys/common/fpga.c
+++ b/board/gdsys/common/fpga.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2013
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/ihs_mdio.c b/board/gdsys/common/ihs_mdio.c
index 262ead5516..822517d4b2 100644
--- a/board/gdsys/common/ihs_mdio.c
+++ b/board/gdsys/common/ihs_mdio.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/ioep-fpga.c b/board/gdsys/common/ioep-fpga.c
index f72a01e5b2..7ebce04a8a 100644
--- a/board/gdsys/common/ioep-fpga.c
+++ b/board/gdsys/common/ioep-fpga.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/miiphybb.c b/board/gdsys/common/miiphybb.c
index 310562902b..09b62253cd 100644
--- a/board/gdsys/common/miiphybb.c
+++ b/board/gdsys/common/miiphybb.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2010
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/osd.c b/board/gdsys/common/osd.c
index add9574369..454468ea3b 100644
--- a/board/gdsys/common/osd.c
+++ b/board/gdsys/common/osd.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2010
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/osd.h b/board/gdsys/common/osd.h
index 5b3f14bf05..a3b0e3d5ae 100644
--- a/board/gdsys/common/osd.h
+++ b/board/gdsys/common/osd.h
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2010
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/common/phy.c b/board/gdsys/common/phy.c
index fb92658178..45d2b81f37 100644
--- a/board/gdsys/common/phy.c
+++ b/board/gdsys/common/phy.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/mpc8308/MAINTAINERS b/board/gdsys/mpc8308/MAINTAINERS
index 21470bf6b0..755b9a2385 100644
--- a/board/gdsys/mpc8308/MAINTAINERS
+++ b/board/gdsys/mpc8308/MAINTAINERS
@@ -1,5 +1,5 @@
 MPC8308 BOARD
-M:	Dirk Eibach <eibach@gdsys.de>
+M:	Dirk Eibach <dirk.eibach@gdsys.cc>
 S:	Maintained
 F:	board/gdsys/mpc8308/
 F:	include/configs/hrcon.h
diff --git a/board/gdsys/mpc8308/Makefile b/board/gdsys/mpc8308/Makefile
index 42702fb967..f9671cfbd6 100644
--- a/board/gdsys/mpc8308/Makefile
+++ b/board/gdsys/mpc8308/Makefile
@@ -1,6 +1,6 @@
 #
 # (C) Copyright 2014
-# Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+# Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
 #
 # SPDX-License-Identifier:	GPL-2.0+
 #
diff --git a/board/gdsys/mpc8308/hrcon.c b/board/gdsys/mpc8308/hrcon.c
index 7e485074ce..8e21724dff 100644
--- a/board/gdsys/mpc8308/hrcon.c
+++ b/board/gdsys/mpc8308/hrcon.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/mpc8308/mpc8308.c b/board/gdsys/mpc8308/mpc8308.c
index 86b257f4de..928f75a02f 100644
--- a/board/gdsys/mpc8308/mpc8308.c
+++ b/board/gdsys/mpc8308/mpc8308.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/mpc8308/strider.c b/board/gdsys/mpc8308/strider.c
index fec691515d..845e4def43 100644
--- a/board/gdsys/mpc8308/strider.c
+++ b/board/gdsys/mpc8308/strider.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/board/gdsys/p1022/MAINTAINERS b/board/gdsys/p1022/MAINTAINERS
index 5119fbb142..99f1200c09 100644
--- a/board/gdsys/p1022/MAINTAINERS
+++ b/board/gdsys/p1022/MAINTAINERS
@@ -1,5 +1,5 @@
 P1022 BOARD
-M:	Dirk Eibach <eibach@gdsys.de>
+M:	Dirk Eibach <dirk.eibach@gdsys.cc>
 S:	Maintained
 F:	board/gdsys/p1022/
 F:	include/configs/controlcenterd.h
diff --git a/drivers/gpio/mpc8xxx_gpio.c b/drivers/gpio/mpc8xxx_gpio.c
index 326fd1672d..c7acf11659 100644
--- a/drivers/gpio/mpc8xxx_gpio.c
+++ b/drivers/gpio/mpc8xxx_gpio.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2016
- * Mario Six, Guntermann & Drunck GmbH, six@gdsys.de
+ * Mario Six, Guntermann & Drunck GmbH, mario.six@gdsys.cc
  *
  * based on arch/powerpc/include/asm/mpc85xx_gpio.h, which is
  *
diff --git a/drivers/gpio/pca9698.c b/drivers/gpio/pca9698.c
index d2663f7331..3995c496ae 100644
--- a/drivers/gpio/pca9698.c
+++ b/drivers/gpio/pca9698.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2011
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/drivers/i2c/ihs_i2c.c b/drivers/i2c/ihs_i2c.c
index ee96cd50d5..9298521220 100644
--- a/drivers/i2c/ihs_i2c.c
+++ b/drivers/i2c/ihs_i2c.c
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2013
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/drivers/tpm/tpm_atmel_twi.c b/drivers/tpm/tpm_atmel_twi.c
index eba654b15d..112883ed83 100644
--- a/drivers/tpm/tpm_atmel_twi.c
+++ b/drivers/tpm/tpm_atmel_twi.c
@@ -1,7 +1,7 @@
 /*
  * Copyright (C) 2013 Guntermann & Drunck, GmbH
  *
- * Written by Dirk Eibach <eibach@gdsys.de>
+ * Written by Dirk Eibach <dirk.eibach@gdsys.cc>
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/include/configs/hrcon.h b/include/configs/hrcon.h
index 44910859cc..a8afb15eba 100644
--- a/include/configs/hrcon.h
+++ b/include/configs/hrcon.h
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  *
  * SPDX-License-Identifier:	GPL-2.0+
diff --git a/include/configs/strider.h b/include/configs/strider.h
index 14b03c813b..9ba52d1303 100644
--- a/include/configs/strider.h
+++ b/include/configs/strider.h
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2014
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  *
  * SPDX-License-Identifier:	GPL-2.0+
diff --git a/include/gdsys_fpga.h b/include/gdsys_fpga.h
index bb8e144e04..10290509f5 100644
--- a/include/gdsys_fpga.h
+++ b/include/gdsys_fpga.h
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2010
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */
diff --git a/include/pca9698.h b/include/pca9698.h
index 9732be661d..c7f3ddd50a 100644
--- a/include/pca9698.h
+++ b/include/pca9698.h
@@ -1,6 +1,6 @@
 /*
  * (C) Copyright 2011
- * Dirk Eibach,  Guntermann & Drunck GmbH, eibach@gdsys.de
+ * Dirk Eibach,  Guntermann & Drunck GmbH, dirk.eibach@gdsys.cc
  *
  * SPDX-License-Identifier:	GPL-2.0+
  */